uses IniFiles, Forms, Dialogs, SysUtils, Classes, Variants, PaxCompilerFramework, XMLChecker, BasicNamespace, ShellAPI; // MSXML, XMLIntf
  // i    XML  IN4
  procedure ConvertActiveXMLtoIn4(App: IchkApplication);
  const
    //   
    sErrorNoOpenIn4 = 'i  i   XML  i';
    sErrorIn4ManyParcels = 'XML   ,     XML';
    sErrorXMLTemplate = '   .   ';
    sCaptionError = '';

  //
  type TProprietor = record
        PName: String[255];
        PType: Integer;
  end;

  //
  function GetValueByKey(Key, ListFile: string): string;
  begin
     Result := App.GetListValueByKey(Key, App.GetListFolderPath + '\' + ListFile, '');
  end;

  function CheckGedDir(var FileName: widestring): Boolean;
  var N       : integer;
      RVal    : string;
      IniFile : TIniFile;
      ScrPath : string;
      selFile : string;
  begin
     //    GED  ini 
     ScrPath  := App.GetThisScriptFolder + '\settings.ini';
     IniFile  := TIniFile.Create(ScrPath);
     FileName := IniFile.ReadString('Main','GED path','');
     Result := true;
     //  ,  i   
     if not FileExists(FileName) then
     begin
        FileName := Application.ExeName;
        RVal := StrReverse( ExtractFileDir(FileName));
        N := Pos('\', RVal);
        Result := false;
        while N > 0 do begin
          if FileExists(StrReverse(RVal) + '\Ged.exe') then
          begin
             Result := true;
             FileName := StrReverse(RVal) + '\Ged.exe';
             IniFile.WriteString('Main','GED path', FileName);
             Break;
          end;
          Delete(RVal, 1, N);
          N := Pos('\', RVal);
        end;
        if Result = false then
           if PromptForFileName(selFile, 'GED  (ged.exe)|ged.exe', '', 'i      Delta Digitals', ExtractFilePath(FileName), false) then
           begin
              IniFile.WriteString('Main','GED path', FileName);
              Result := true;
           end;
     end;
  end;

  //      XML
  function GetFullNameFromPath(ObjectXML: IchkXMLObject; XMLPath: WideString): TProprietor;
  var WLastName, WFirstName, WMiddleName, WFullName: WideString;
  begin
     Result.PType := 0;  //    - i 
     if ObjectXML.PathExists(XMLPath + '/NaturalPerson') then //
     begin
        ObjectXML.GetValue(XMLPath + '/NaturalPerson/FullName/LastName',   WLastName);
        ObjectXML.GetValue(XMLPath + '/NaturalPerson/FullName/FirstName',  WFirstName);
        ObjectXML.GetValue(XMLPath + '/NaturalPerson/FullName/MiddleName', WMiddleName);
        WFullName := WLastName + ' ' + WFirstName + ' ' + WMiddleName;
     end else
     if ObjectXML.PathExists(XMLPath + '/LegalEntity') then
     begin
        ObjectXML.GetValue(XMLPath + '/LegalEntity/Name', WFullName);
        Result.PType := 1; //  - . 
     end else
     begin
        ObjectXML.GetValue(XMLPath + '/LastName',   WLastName);
        ObjectXML.GetValue(XMLPath + '/FirstName',  WFirstName);
        ObjectXML.GetValue(XMLPath + '/MiddleName', WMiddleName);

        WFullName := WLastName + ' ' + WFirstName + ' ' + WMiddleName;
     end;
     Result.PName := WFullName;
  end;

  //  Index   Value, i Separator
  function StringPart(Value: String; Index: Integer; Separator: String):String;
  var RVal  : String;
      I, N  : Integer;
  begin
     RVal  := '';
     Value := Value + Separator;
     N := Pos(Separator, Value);
     I := 0;
     while N > 0 do begin
	     RVal := Copy(Value, 0, N-1);
       if Index = I then Break;
       Delete(Value, 1, N);
       I := I + 1;
       N := Pos(Separator, Value);
     end;
     Result := RVal;
  end;

  //  Index    ii  Value
  function DelStringPart(Value: String; Index: Integer; Separator: String):String;
  var I, N  : Integer;
      RVal  : String;
  begin
     RVal  := '';
     Value := Value + Separator;
     N := Pos(Separator, Value);
     I := 0;
     while N > 0 do begin
       if Index <> I then begin
          if RVal='' then RVal := Copy(Value, 0, N-1)
	        else RVal := RVal + '|' + Copy(Value, 0, N-1);
       end;
       Delete(Value, 1, N);
       I := I + 1;
       N := Pos(Separator, Value);
     end;
     Result := RVal;
  end;

  //   i   ii  Value
  function RMDuplicate(Value: String): String;
  var Parts : TStringDynArray;
      I,J,K : Integer;
      N, Cnt: Integer;
      RVal  : String;
      S1,S2 : String;
  begin
     Parts := SeparateString(Value, ',');
     { - i }
     if (Length(Parts) > 0) then N := Length(SeparateString(Parts[0], '|'))
     else N := 0;
     for I := 0 to N - 1 do begin
       for J := I + 1 to N - 1 do begin
         Cnt := 0;
         for K := 0 to Length(Parts)-1 do begin
         S1:=StringPart(Parts[K],I,'|');
         S2:=StringPart(Parts[K],J,'|');
            if StringPart(Parts[K],I,'|') = StringPart(Parts[K],J,'|') then
               Cnt := Cnt + 1;
         end;
         if Cnt=Length(Parts) then begin
            for K := 0 to Length(Parts)-1 do
               Parts[K] := DelStringPart(Parts[K], I, '|');
            N:=N-1;
         end;
       end;
     end;
     for K := 0 to Length(Parts)-1 do
        if RVal='' then RVal := Parts[K]
        else RVal := RVal + ',' + Parts[K];
     Result := RVal;
  end;

  //
  function DescEmpty(Value: String): Boolean;
  begin
     if TrimString(Value, [',', '|']) = '' then Result := true
     else Result := false;
  end;

  //    i  in4
  function DescFmt(Value: String): String;
  begin
     if Value = '' then Value := '-';
     Result := Value;
  end;

  //   i  In4
  function XMLToIn4Date(XMLDate: string): string;
  var Parts: TStringDynArray;
  begin
     Parts := SeparateString(XMLDate, '-');
     if Length(Parts) >= 3 then
        Result := Parts[2] + '.' + Parts[1] + '.' + Parts[0]
     else
        Result := '';
  end;

  // i ()   in4
  procedure SetValueIn4(ObjectIN4: IchkIn4Object; DescrName, Value: String);
  var     Descr: IchkIn4Descriptor;
  begin
     if DescEmpty(Value) then Value := '-';
     Descr := ObjectIN4.DescriptorByName(DescrName);
     try
        Descr.Value := Value;
     except
        Descr := ObjectIN4.AddDescriptorFromString(DescrName + '=');
        Descr.Value := Value;
     end;
  end;

  //     
  function GetKeyByColumnValue(ColValue, ListFile: WideString; ColIndex: Integer): String;
  var MFile  : TStrings;
      WSTR   : WideString;
      Parts  : TStringDynArray;
      Column : Integer;
  begin
     Column := App.GetValueIndexInList(ColValue, App.GetListFolderPath + '\' + ListFile, ColIndex);
     if Column >= 0 then
     begin
        MFile  := TStringList.Create;
        MFile.LoadFromFile(App.GetListFolderPath + '\' + ListFile);
        WSTR   := MFile.Get(Column);
        Parts  := SeparateString(WSTR, #9);
        MFile.Clear;
        Result := Parts[0];
     end else Result := '';
  end;

  var
    I: Integer;
    Area, Perimeter: String;
    XMLFile: IchkUkrainianCadastralExchangeFile;
    In4File: IchkIn4File;
    ActiveTab: IchkXMLTab;
    In4Parcel: IchkIn4Parcel;
    In4LandParcel: IchkIn4LandParcel;
    XMLLandParcel: IchkXMLLandParcel;
    In4Neighbor: IchkIn4Neighbor;
    XMLNeighbor: IchkXMLNeighbor;
    XMLRestrictions: IchkXMLRestriction;
    XMLProprietor: IchkXMLCompanyOrPerson;
    FileTab: IchkFileTab;
    CSIn4, CSIn4Kind, CSIn4Descr, CSXMLName,
    HSXMLName, HSIn4Kind,
    NMDesc, AUDesc, PPDesc, KFDesc, VPDesc, KZDesc, PZDesc, CVDesc, TXDesc, TDDesc, SCDesc: WideString;
    WCountry, WZIP, WRegion, WDistrict, WSettlement, WStreet, WBuilding, WBlock, WBuildingUnit: WideString;
    WCountryP, WZIPP, WRegionP, WDistrictP, WSettlementP, WStreetP, WBuildingP, WBlockP, WBuildingUnitP: WideString;
    WDocumentType, WPassportIssuedDate, WIssuanceAuthority, WPassportSeries: WideString;
    WDocumentTypeP, WPassportNumberP, WPassportIssuedDateP, WIssuanceAuthorityP, WPassportSeriesP: WideString;
    WDocument, WDocumentDate, WDocumentNumber, WApprovalAuthority: WideString;
    WDocumentP, WDocumentDateP, WDocumentNumberP, WApprovalAuthorityP: WideString;
    WBookNumber, WRegDate: WideString;
    WFirmName, WUserName : WideString;
    WStreetType, WStreetName: WideString;
    Numerator, Denominator: WideString;
    XMLPath: WideString;
    Parts: TStringDynArray;
    sPath: WideString;
    WSTR: WideString;
    Proprietor: TProprietor;
    selFile: string;
    FileName: WideString;
    Cycle: Boolean;

    XMLDoc: Variant;
    Ged   : Variant;
    Node  : Variant;
  begin
    if App = nil then Exit;
    //    XML 
    FileTab := App.MainWindow.FileTabs.ActiveTab;
    if (FileTab = nil) or (FileTab.TabKind <> chktabXML) then
    begin
      // XML  ,  
      App.DisplayHint(chkikError, App.Translate(sCaptionError), App.Translate(sErrorNoOpenIn4));
      //   
      Abort;
    end;

    //  XML   
    ActiveTab := FileTab.AsXMLTab;
    // '-  
    XMLFile := App.CreateUkrainianCadastralExchangeFile;
    //  XML     
    XMLFile.LoadFromXMLDocument(ActiveTab.XMLDocument);

    //  '-IN4 
    In4File := App.CreateIn4File;
    sPath := App.GetScriptFolderPath + '/In4Template.in4';
    if not FileExists(sPath) then begin
      App.DisplayHint(chkikError, App.Translate(sCaptionError), App.Translate(sErrorXMLTemplate));
      In4File.Text:='# XMLChecker (ConvertXMLToIn4 v.1.0a) (c) 2017 by R.Parkhuts email:Parkhuts@meta.ua #'#13#10'BL,'#13#10'SR,';
      //Abort;
    end else begin
      In4File.LoadFromFile(sPath);
    end;
    { i  5 i }
    In4File.CoordinateDecimals:=5;

    // DS, SD
    if XMLFile.CadastralZone.GetValue('KOATUU', WSTR) then begin
       SetValueIn4(In4File.Quarter,'DS',WSTR);
       if XMLFile.CadastralZone.GetValue('CadastralZoneNumber', WSTR) then begin
          SetValueIn4(In4File.Quarter,'SD',WSTR);
       end; // i  
    end else if XMLFile.CadastralZone.GetValue('CadastralZoneNumber', WSTR) then begin
       Parts:=SeparateString(WSTR, ':');
       SetValueIn4(In4File.Quarter,'DS',Parts[0]);
       if Length(Parts) = 2 then begin
          SetValueIn4(In4File.Quarter,'SD',Parts[1]);
       end; // i  
    end;

    // BC
    if XMLFile.CadastralQuarter.GetValue('CadastralQuarterNumber', WSTR) then begin
       SetValueIn4(In4File.Quarter,'BC',CStr(WSTR));
       SCDesc := WSTR; { }
    end;

    // GL
    WSTR:=GetFullNameFromPath(XMLFile.CadastralQuarter,'RegionalContacts/LocalAuthorityHead').PName;
    SetValueIn4(In4File.Quarter,'GL',CStr(WSTR));

    // ZM
    WSTR:=GetFullNameFromPath(XMLFile.CadastralQuarter,'RegionalContacts/DKZRHead').PName;
    SetValueIn4(In4File.Quarter,'ZM',CStr(WSTR));

    // SZ
    SetValueIn4(In4File.Quarter,'SZ','.');

    { DOM }
    FileName:=App.MainWindow.FileTabs.Tabs[FileTab.TabIndex].FileName;
    XMLDoc := CreateOleObject('MSXML2.DOMDocument');
    XMLDoc.Load(FileName);
    if XMLDoc.parseError.errorCode <> 0 then begin
       App.DisplayHint(chkikError, App.Translate('XMLDOM critical error'), App.Translate('Error reading XML file to DOM schema'));
       Abort;
    end;

    // CS -  
    Node := XMLDoc.selectSingleNode('//InfoPart/MetricInfo/CoordinateSystem');
    try
      CSXMLName := Node.childNodes[0].nodeName;
      if CSXMLName = 'SC42' then CSIn4Kind := '0' else
        if CSXMLName = 'SC42_3' then CSIn4Kind := '1' else
          if CSXMLName = 'SC63' then CSIn4Kind := '2' else
            if CSXMLName = 'Local' then CSIn4Kind := '3' else
               CSIn4Kind := '2';
      try
         CSIn4Descr := Node.childNodes[0].childNodes[0].nodeName;
         if (CSIn4Kind = '2') then begin
            if (CSIn4Descr = '') or not (CSIn4Descr[1] in ['X', 'C', 'P', 'T']) then
               CSIn4Descr := 'X';
            CSIn4 := CSIn4Kind + ',' + CSIn4Descr[1];
         end;
      Except
         CSIn4 := CSIn4Kind + ',-';
      end;
    Except
      CSIn4 := '2,X';
    end;
    SetValueIn4(In4File.Quarter,'CS',CSIn4);

    // HS -  
    Node := XMLDoc.selectSingleNode('//InfoPart/MetricInfo/HeightSystem');
    try
      HSXMLName := Node.childNodes[0].nodeName;
      if HSXMLName = 'Baltic77' then HSIn4Kind := '0'  else
        if HSXMLName = 'Baltic' then HSIn4Kind := '1' else
           HSIn4Kind := '2';
    Except
      HSIn4Kind := '2';
    end;
    SetValueIn4(In4File.Quarter,'HS',HSIn4Kind);

    {    i }
    if XMLFile.CadastralQuarter.Geometry <> nil then begin
       // 
       In4File.Quarter.Geometry := XMLFile.CadastralQuarter.Geometry;
       Area  := Replace(FormatFloat('0.000000', XMLFile.CadastralQuarter.Geometry.Area / 10000),',','.');
       Perimeter := Replace(FormatFloat('0.000000',XMLFile.CadastralQuarter.Geometry.Perimeter),',','.');
    end else begin
       //  (  i  i )
       In4File.Quarter.Geometry := XMLFile.Parcel.Geometry;
       Area  := Replace(FormatFloat('0.000000', XMLFile.Parcel.Geometry.Area / 10000),',','.');
       Perimeter := Replace(FormatFloat('0.000000',XMLFile.Parcel.Geometry.Perimeter),',','.');
    end;
    // AB, PB, MB
    SetValueIn4(In4File.Quarter,'AB',CStr(Area));
    SetValueIn4(In4File.Quarter,'PB',CStr(Perimeter));
    SetValueIn4(In4File.Quarter,'MB','0.0006');

    // ---> i
    In4Parcel := In4File.Quarter.Parcels[0];
    In4Parcel.Geometry := XMLFile.Parcel.Geometry;

    // SC
    XMLFile.Parcel.GetValue('ParcelMetricInfo/ParcelID', WSTR);
    if TrimString(WSTR, ['-', '0', ' ']) <> '' then
       SCDesc := SCDesc + WSTR;
    SetValueIn4(In4Parcel, 'SC', SCDesc);

    // NM
    NMDesc := ''; AUDesc := ''; PPDesc := ''; KFDesc := ''; VPDesc := '';
    for I:=0 to XMLFile.Parcel.ProprietorCount -1 do
    begin
       // NM
       XMLProprietor := XMLFile.Parcel.Proprietors[I];
       Proprietor:=GetFullNameFromPath(XMLProprietor, '/Authentication');
       if I=0 then   NMDesc := Proprietor.PName
       else          NMDesc := NMDesc + '|' + AnsiString(Proprietor.PName);

       // KF, KU  =0 - i 
       if Proprietor.PType = 0 then
       begin
           XMLProprietor.GetValue('/Authentication/NaturalPerson/TaxNumber', WSTR);
           XMLPath := '/Authentication/NaturalPerson'; {      AU }
       end else begin
           XMLProprietor.GetValue('/Authentication/LegalEntity/EDRPOU', WSTR);
           XMLPath := '/Authentication/LegalEntity';   {      AU }
       end;
       if I = 0 then KFDesc := DescFmt(WSTR)
       else          KFDesc := KFDesc + '|' + DescFmt(WSTR);
       // PP
       if Proprietor.PType = 0 then
       begin
           XMLProprietor.GetValue('/Authentication/NaturalPerson/Passport/DocumentType', WDocumentTypeP);
           XMLProprietor.GetValue('/Authentication/NaturalPerson/Passport/PassportNumber', WPassportNumberP);
           XMLProprietor.GetValue('/Authentication/NaturalPerson/Passport/PassportIssuedDate', WPassportIssuedDateP);
           XMLProprietor.GetValue('/Authentication/NaturalPerson/Passport/IssuanceAuthority', WIssuanceAuthorityP);
           XMLProprietor.GetValue('/Authentication/NaturalPerson/Passport/PassportSeries', WPassportSeriesP);

           WPassportIssuedDateP := XMLToIn4Date(WPassportIssuedDateP);
           WDocumentTypeP:=GetKeyByColumnValue(WDocumentTypeP, 'In4ToXMLPassportTypes.txt', 1);
           if I = 0 then begin
              WDocumentType       := WDocumentTypeP;
              WPassportSeries     := WPassportSeriesP  + ' ' + WPassportNumberP;
              WPassportIssuedDate := WPassportIssuedDateP;
              WIssuanceAuthority  := WIssuanceAuthorityP;
           end else begin
              WDocumentType       := WDocumentType       + '|' + WDocumentTypeP;
              WPassportSeries     := WPassportSeries     + '|' + WPassportSeriesP + ' ' + WPassportNumberP;
              WPassportIssuedDate := WPassportIssuedDate + '|' + WPassportIssuedDateP;
              WIssuanceAuthority  := WIssuanceAuthority  + '|' + WIssuanceAuthorityP;
           end;
       end;

       // AU
       XMLProprietor.GetValue(XMLPath + '/Address/Country',     WCountryP);
       XMLProprietor.GetValue(XMLPath + '/Address/ZIP',         WZIPP);
       XMLProprietor.GetValue(XMLPath + '/Address/Region',      WRegionP);
       XMLProprietor.GetValue(XMLPath + '/Address/District',    WDistrictP);
       XMLProprietor.GetValue(XMLPath + '/Address/Settlement',  WSettlementP);
       XMLProprietor.GetValue(XMLPath + '/Address/Street',      WStreetP);
       XMLProprietor.GetValue(XMLPath + '/Address/Building',    WBuildingP);
       XMLProprietor.GetValue(XMLPath + '/Address/Block',       WBlockP);
       XMLProprietor.GetValue(XMLPath + '/Address/BuildingUnit',WBuildingUnitP);
       if I = 0 then begin
          WCountry      := DescFmt(WCountryP);
          WZIP          := DescFmt(WZIPP);
          WRegion       := DescFmt(WRegionP);
          WDistrict     := DescFmt(WDistrictP);
          WSettlement   := DescFmt(WSettlementP);
          WStreet       := DescFmt(WStreetP);
          WBuilding     := DescFmt(WBuildingP);
          WBlock        := DescFmt(WBlockP);
          WBuildingUnit := DescFmt(WBuildingUnitP);
       end else begin
          WCountry      := WCountry + '|' + DescFmt(WCountryP);
          WZIP          := WZIP + '|' + DescFmt(WZIPP);
          WRegion       := WRegion + '|' + DescFmt(WRegionP);
          WDistrict     := WDistrict + '|' + DescFmt(WDistrictP);
          WSettlement   := WSettlement + '|' + DescFmt(WSettlementP);
          WStreet       := WStreet + '|' + DescFmt(WStreetP);
          WBuilding     := WBuilding + '|' + DescFmt(WBuildingP);
          WBlock        := WBlock + '|' + DescFmt(WBlockP);
          WBuildingUnit := WBuildingUnit + '|' + DescFmt(WBuildingUnitP);
       end;

       // VP
       WSTR := '';
       if XMLProprietor.PathExists('ParcelPart') then
       begin
         if XMLProprietor.PathExists('ParcelPart/Percent') then
             if XMLProprietor.GetValue('ParcelPart/Percent', WSTR) then
                if WSTR = '' then WSTR := '-'
                else WSTR := WSTR + '%'
         else begin
             XMLProprietor.GetValue('ParcelPart/Part/Numerator', Numerator);
             XMLProprietor.GetValue('ParcelPart/Part/Denominator', Denominator);
             WSTR := Numerator + '/' + Denominator;
         end;
       end;
       if I = 0 then VPDesc := WSTR
       else          VPDesc := VPDesc + '|' + WSTR;

       // KZ
       if XMLProprietor.GetValue('ProprietorCode', WSTR) then
       begin
          if I = 0 then KZDesc := WSTR;
          if I > 0 then begin
             if KZDesc = '' then KZDesc := WSTR;
          end;
       end else KZDesc := '-';

       // PZ
       if XMLProprietor.PathExists('PropertyAcquisitionJustification') then
       begin
          XMLProprietor.GetValue('PropertyAcquisitionJustification/Document', WDocumentP);
          XMLProprietor.GetValue('PropertyAcquisitionJustification/DocumentDate', WDocumentDateP);
          XMLProprietor.GetValue('PropertyAcquisitionJustification/DocumentNumber', WDocumentNumberP);
          XMLProprietor.GetValue('PropertyAcquisitionJustification/ApprovalAuthority', WApprovalAuthorityP);
       end;
       if I = 0 then begin
          WDocument          := DescFmt(WDocumentP);
          WDocumentDate      := DescFmt(WDocumentDateP);
          WDocumentNumber    := DescFmt(WDocumentNumberP);
          WApprovalAuthority := DescFmt(WApprovalAuthorityP);
       end else begin
          WDocument          := WDocument + '|' + DescFmt(WDocumentP);
          WDocumentDate      := WDocumentDate + '|' + DescFmt(WDocumentDateP);
          WDocumentNumber    := WDocumentNumber + '|' + DescFmt(WDocumentNumberP);
          WApprovalAuthority := WApprovalAuthority + '|' + DescFmt(WApprovalAuthorityP);
       end;
    end;
    AUDesc := WCountry + ',' + WZIP + ',' + WRegion + ',' + WDistrict + ',' + WSettlement + ',' + WStreet + ',' + WBuilding + ',' + WBlock + ',' + WBuildingUnit;
    PZDesc := WDocument + ',' + WDocumentDate + ',' + WDocumentNumber + ',' + WApprovalAuthority;
    SetValueIn4(In4Parcel, 'NM', NMDesc);
    SetValueIn4(In4Parcel, 'AU', AUDesc);
    SetValueIn4(In4Parcel, 'VP', VPDesc);
    SetValueIn4(In4Parcel, 'KZ', KZDesc);
    SetValueIn4(In4Parcel, 'PZ', RMDuplicate(PZDesc));
    if Proprietor.PType = 0 then
    begin
       PPDesc := WDocumentType + ',' + WPassportSeries + ',' + WPassportIssuedDate + ',' + WIssuanceAuthority;
       SetValueIn4(In4Parcel,'KF',KFDesc);
       SetValueIn4(In4Parcel,'PP',PPDesc);
    end else
       SetValueIn4(In4Parcel,'KU',KFDesc);

    // AD
    XMLFile.Parcel.GetValue('ParcelLocationInfo/Settlement', WSettlement);
    XMLFile.Parcel.GetValue('ParcelLocationInfo/ParcelAddress/StreetType', WStreetType);
    XMLFile.Parcel.GetValue('ParcelLocationInfo/ParcelAddress/StreetName', WStreetName);
    XMLFile.Parcel.GetValue('ParcelLocationInfo/ParcelAddress/Building', WBuilding);
    SetValueIn4(In4Parcel,'AD',WSettlement + ',' + WStreetType + ' ' + WStreetName + ',' + WBuilding);

    // CV
    XMLFile.Parcel.GetValue('CategoryPurposeInfo/Purpose', CVDesc);
    if CVDesc <> '' then
       TXDesc := TrimString(GetValueByKey(CVDesc, 'Purpose.txt'),[' ','']);
    if TXDesc <> '' then
       CVDesc := CVDesc + ' ' + AnsiLowerCase(TXDesc);
    SetValueIn4(In4Parcel, 'TX', DescFmt(TXDesc));
    SetValueIn4(In4Parcel, 'CV', DescFmt(CVDesc));

    // TD
    XMLFile.Parcel.GetValue('TechnicalDocumentationInfo/DocumentationType', WDocumentType);
    if WDocumentType <> '' then WDocumentType:=GetKeyByColumnValue(WDocumentType, 'In4ToXMLDocumentationType.txt', 1)
    else WDocumentType := '-';
    XMLFile.Parcel.GetValue('TechnicalDocumentationInfo/DraftingDate', WDocumentDate);
    if WDocumentDate <> '' then WDocumentDate := XMLToIn4Date(WDocumentDate)
    else WDocumentDate := '-';
    XMLFile.Parcel.GetValue('TechnicalDocumentationInfo/RegistrationData/RegistrationAuthority', WFirmName);
    WUserName   := GetFullNameFromPath(XMLFile.Root, 'AdditionalPart/InfoLandWork/Executor/Executor/ExecutorName').PName;
    XMLFile.Parcel.GetValue('TechnicalDocumentationInfo/RegistrationData/BookNumber', WBookNumber);
    XMLFile.Parcel.GetValue('TechnicalDocumentationInfo/RegistrationData/RegistrationDate', WRegDate);
    WFirmName   := DescFmt(WFirmName);
    WUserName   := DescFmt(WUserName);
    WBookNumber := DescFmt(WBookNumber);
    WRegDate    := DescFmt(XMLToIn4Date(WRegDate));
    TDDesc := WDocumentType + ',' + WDocumentDate + ',' + WFirmName + ',' + WUserName + ',' + WBookNumber + ',' + WRegDate;
    SetValueIn4(In4Parcel, 'TD', DescFmt(TDDesc));

    // AS, PS, MS
    Area  := Replace(FormatFloat('0.000000', In4Parcel.Geometry.Area / 10000),',','.');
    Perimeter := Replace(FormatFloat('0.000000',In4Parcel.Geometry.Perimeter),',','.');
    SetValueIn4(In4Parcel,'AS',CStr(Area));
    SetValueIn4(In4Parcel,'PS',CStr(Perimeter));
    SetValueIn4(In4Parcel,'MS','0.0006');
    // <--- i ' i

    // ---> i
    for I:=0 to XMLFile.Parcel.LandParcelCount -1 do
    begin
      XMLLandParcel := XMLFile.Parcel.LandParcels[I];
      In4LandParcel := In4Parcel.AddNewLandParcel;
      In4LandParcel.Geometry := XMLLandParcel.Geometry;


      XMLLandParcel.GetValue('CadastralCode', WSTR);
      SetValueIn4(In4LandParcel, 'LC', WSTR);
      XMLLandParcel.GetValue('LandCode', WSTR);
      SetValueIn4(In4LandParcel, 'CN', WSTR);

      Area  := Replace(FormatFloat('0.000000', XMLLandParcel.Geometry.Area / 10000),',','.');
      Perimeter := Replace(FormatFloat('0.000000',XMLLandParcel.Geometry.Perimeter),',','.');
      SetValueIn4(In4LandParcel,'AL',CStr(Area));
      SetValueIn4(In4LandParcel,'PL',CStr(Perimeter));
      SetValueIn4(In4LandParcel,'ML','0.0006');
    end;
    // <--- i

    // --->  (  i  ii )
    for I:=0 to XMLFile.Parcel.RestrictionCount -1 do
    begin
      XMLRestrictions := XMLFile.Parcel.Restrictions[I];
      In4LandParcel := In4Parcel.AddNewLandParcel;
      In4LandParcel.Geometry := XMLRestrictions.Geometry;

      XMLRestrictions.GetValue('RestrictionCode', WSTR);
      SetValueIn4(In4LandParcel, 'LS', WSTR);

      Area  := Replace(FormatFloat('0.000000', XMLRestrictions.Geometry.Area / 10000),',','.');
      Perimeter := Replace(FormatFloat('0.000000',XMLRestrictions.Geometry.Perimeter),',','.');
      SetValueIn4(In4LandParcel,'AL',CStr(Area));
      SetValueIn4(In4LandParcel,'PL',CStr(Perimeter));
      SetValueIn4(In4LandParcel,'ML','0.0006');
    end;
    // <--- 

    // ---> i
    for I := 0 to XMLFile.Parcel.NeighborCount -1 do
    begin
      XMLNeighbor := XMLFile.Parcel.Neighbors[I];
      In4Neighbor := In4File.Quarter.AddNewNeighbor;
      In4Neighbor.Geometry := XMLNeighbor.Geometry;
      WSTR := XMLNeighbor.XPath;

      WSTR := GetFullNameFromPath(XMLNeighbor, '/Proprietor').PName;
      SetValueIn4(In4Neighbor, 'NM', WSTR);
    end;
    // <--- i

    // i  XML  i ,  i In4
    selFile := ChangeFileExt(App.MainWindow.FileTabs.Tabs[FileTab.TabIndex].FileName, '.in4');

    if FileExists(selFile) then Cycle := true;
    while Cycle do begin
       if PromptForFileName(selFile, 'IN4  (*.in4)|*.in4', 'in4', 'i i i  In4', ExtractFilePath(selFile), true) then
          Cycle := false
       else Abort();
    end;
    In4File.SaveToFile(selFile);

    //     XML
    App.MainWindow.FileTabs.CloseTab(FileTab.TabIndex);

    //   XML
    //App.MainWindow.LoadFile(FileName);
    if CheckGedDir(FileName) then begin
       Ged := CreateOleObject('WScript.Shell');
       FileName := FileName + ' ' + selFile;
       if not VarIsNull(Ged) then Ged.Run(FileName, 1);
    end else ShowMessage(' In4 : ' + FileName);
  end;
var
  App: IchkApplication;
begin

  //      
  CheckScriptVersion(1.1);

  //  '-
  App := CreateApplication;
  //   
  App.InitLocalizer(App.GetThisScriptFolder + '\' + 'Messages.lng', 'uk');

  //     In4  XML
  ConvertActiveXMLtoIn4(App);
end.